///////////////////////////////////////////////////
//Mathematisches Pendel im Schwerefeld
//Numerische Näherung der DGL  w'' = -K sin(w) durch
//Symplectic Euler. Vorteil: Energie bleibt erhalten.
//Dient der Vorbereitung des Kicked Rotators
/////////////////////////////////////////////////////

float l = 2.50;  //Pendellänge in Meter
float lP = 250; //Pendellänge in Pixel
float wAlt = 3*PI/4;//Winkel zu Beginn
float gAlt = -3.95;//Winkelgeschwindigkeit zu Beginn. So noch kein Überschlag
float dt = 0.01;//Zeitintervall
float g = 9.81;//Erdbeschleunigung
float wNeu, gNeu;//Neuer Winkel, neue Winkelgeschwindigkeit
float K = l/g;
float wK, gK;//Für eventuelles Phasendiagramm
int t = 0;
color farbe = color(255,0,0);

void setup() {
  size(600, 1200); 
  ellipseMode(CENTER);
  background(0);
}

void draw(){
 // t++;
 //if(abs(wNeu) <= 0.05 ) println(t);
 // background(255);
  fill(255);
  noStroke();
  rect(0,0,600,600);//Pendelbild löschen
  wNeu = wF(wAlt, gAlt);
  gNeu = gF(wAlt, gAlt);
  fill(200,0,0);
  ellipse(300,300,25,25);
  stroke(30);
  strokeWeight(8);
  line(300,300,300 + lP*cos(PI/2-wNeu), 300 + lP*sin(PI/2-wNeu));
  strokeWeight(2);
  fill(0,0,100);
  ellipse(300 + lP*cos(PI/2-wNeu), 300 + lP*sin(PI/2-wNeu),54,54);
  wK = map(wNeu,-PI,PI,10,590);    //Winkel auf Bilde-x-Koordinaten mappen
  gK = map(gNeu,-10-abs(gAlt)/2, 10+abs(gAlt)/2,600,1200); //Winkelgeschw. auf Bilde-y-Koordinaten mappen
  stroke(farbe);
  point(wK,gK);
  stroke(0); 
  line(0,600,600,600);
  wAlt = wNeu;
  gAlt = gNeu;
}

//Symplectic Euler in w und g
float wF(float w, float g) {
  wNeu =(w + dt*g) ;
  if(abs(wNeu) > PI) wNeu = -wNeu;//-PI/2 < w < PI/2
  return wNeu ;
}

float gF(float w, float g) {
  gNeu = g -K*sin(w+dt*g);
  return gNeu;
}
//Startpunkt des Pendels verändern und zufällige Winkelgeschwindigkeit wählen
void mousePressed(){
  if (mouseY < 300 & mouseX < 300) wAlt = map(mouseY+50, 50,300, -PI,-PI/2);
   else if (mouseY >= 300 & mouseX < 300) wAlt = map(mouseY, 300,550, -PI/2,0);
    else if (mouseY < 300 & mouseX >= 300) wAlt = map(mouseY+50, 50,300, PI,PI/2);
     else if (mouseY >= 300 & mouseX >= 300) wAlt = map(mouseY, 300,550, PI/2,0);
  gAlt = random(-10,10);
  farbe = color(random(100,255),random(100,255),random(100,255));
}